#include "stdafx.h"

int getcur(void) {

	CONSOLE_SCREEN_BUFFER_INFO wBuff;

	tscreen.screen = GetStdHandle(STD_OUTPUT_HANDLE);
	GetConsoleScreenBufferInfo(tscreen.screen,&wBuff);

	tscreen.window = wBuff.srWindow;
	tscreen.rows = (tscreen.window.Bottom - tscreen.window.Top) + 1;
	tscreen.columns = (tscreen.window.Right - tscreen.window.Left) + 1;

	if ((tscreen.rows == 1) && (tscreen.columns == 1))
		if (tscreen.window.Bottom < 0) {
			tscreen.rows = 25;
			tscreen.columns = 80;
			if (bgiven.dansi == 0)
				bgiven.dcolor = 1;
			bgiven.dbrowse = 1;
			bgiven.dclear = 0;
			tscreen.Oattrib = 0x0007;
			tscreen.Cattrib = 0x0007;
			return(0);
		}

	if (tscreen.columns < 13) return(-1);
	if (tscreen.rows < 5) return(-2);

	tscreen.Oattrib = wBuff.wAttributes;
	tscreen.Cattrib = tscreen.Oattrib;

	return(0);
}

void scurs(BOOL i) {

	CONSOLE_CURSOR_INFO cur;

	GetConsoleCursorInfo(tscreen.screen,&cur);

	if (cur.bVisible == i) return;
	cur.bVisible = i;
	SetConsoleCursorInfo(tscreen.screen,&cur);

	return;
}

void sclear(void) {

	COORD Wndow;
	short i;

	Wndow.X = tscreen.window.Left;

	for (i = tscreen.window.Top; i <= tscreen.window.Bottom; i++) {
		Wndow.Y = i;
		FillConsoleOutputCharacterA(tscreen.screen,' ',(DWORD)tscreen.columns,Wndow,NULL);
	}
	Wndow.Y = tscreen.window.Top;
	SetConsoleCursorPosition(tscreen.screen,Wndow);

	return;
}

void c_print(char *x) {

	int i = 0;
	WORD rc = 0;
	unsigned char crow = 0, ccol = 0;
	char dansi[13] = "\x1b[37;40";

	if (bgiven.dcolor) printf(x);

	else if (bgiven.dansi) {
		crow = char(tscreen.Cattrib & 0x00ff);
		
		i = 7;
		if (crow & 0x80) {dansi[i++] = ';';dansi[i++] = '5';}
		if (crow & 0x08) {dansi[i++] = ';';dansi[i++] = '1';}
		dansi[i++] = 'm';
		dansi[i] = '\0';

		ccol = (crow >> 4) & 0x07;
		crow &= 0x07;

		if (ccol == 1) ccol = 4;
			else if (ccol == 4) ccol = 1;
		if (ccol == 3) ccol = 6;
			else if (ccol == 6) ccol = 3;
		if (crow == 1) crow = 4;
			else if (crow == 4) crow = 1;
		if (crow == 3) crow = 6;
			else if (crow == 6) crow = 3;

		dansi[6] = char(ccol) + '0';
		dansi[3] = char(crow) + '0';

		printf(dansi);
		printf(x);

		printf("\x1b[0m");

	} else {
		
		SetConsoleTextAttribute(tscreen.screen,tscreen.Cattrib);
		printf(x);
		SetConsoleTextAttribute(tscreen.screen,tscreen.Oattrib);
	}

	return;
}

void scrlfor(void) {

	COORD NewLoc;
	CHAR_INFO fChar;
	SMALL_RECT nWin;
	
	NewLoc.X = tscreen.window.Left;
	NewLoc.Y = tscreen.window.Top;

	fChar.Attributes = tscreen.Cattrib;
	fChar.Char.AsciiChar = ' ';
	
	--tscreen.window.Bottom;
	nWin = tscreen.window;
	++nWin.Top;
	ScrollConsoleScreenBufferA(tscreen.screen,&nWin,&tscreen.window,NewLoc,&fChar);
	++tscreen.window.Bottom;
	
	NewLoc.X = tscreen.window.Left;
	NewLoc.Y = (tscreen.window.Bottom - 1);

	SetConsoleCursorPosition(tscreen.screen,NewLoc);

	return;
}

void scrlback(void) {

	COORD NewLoc;
	CHAR_INFO fChar;
	
	NewLoc.X = tscreen.window.Left;
	NewLoc.Y = (tscreen.window.Top + 1);

	fChar.Attributes = tscreen.Cattrib;
	fChar.Char.AsciiChar = ' ';

	--tscreen.window.Bottom;
	ScrollConsoleScreenBufferA(tscreen.screen,&tscreen.window,&tscreen.window,NewLoc,&fChar);
	++tscreen.window.Bottom;
	
	NewLoc.X = tscreen.window.Left;
	NewLoc.Y = tscreen.window.Top;
	SetConsoleCursorPosition(tscreen.screen,NewLoc);

	return;
}

void lastrow(void) {

	COORD NewLoc;

	NewLoc.X = tscreen.window.Left;
	NewLoc.Y = tscreen.window.Bottom;

	SetConsoleCursorPosition(tscreen.screen,NewLoc);

	return;
}

void ClearLine(void) {

	COORD Wndow;

	Wndow.Y = tscreen.window.Bottom;
	Wndow.X = tscreen.window.Left;

	FillConsoleOutputCharacterA(tscreen.screen,' ',(DWORD)tscreen.columns,Wndow,NULL);

	SetConsoleCursorPosition(tscreen.screen,Wndow);

	return;
}